from sqlmodel import Field, SQLModel, MetaData, JSON, TEXT, Relationship, Column
from ..config import conf, Map, Measures, Geo
from .authentication import UserRead

class Proj(SQLModel):
    srid: str
    srid_for_proj: str

class BootstrapData(SQLModel):
    version: str = conf.version
    title: str = conf.gisaf.title
    windowTitle: str = conf.gisaf.windowTitle
    map: Map = conf.map
    geo: Geo = conf.geo
    measures: Measures = conf.measures
    redirect: str = conf.gisaf.redirect
    user: UserRead | None = None