from datetime import datetime
from sqlalchemy import BigInteger
from sqlmodel import Field, SQLModel, MetaData, JSON, TEXT, Relationship, Column, String

from .models_base import Model
from .metadata import gisaf_admin


class Reconciliation(Model):
    metadata = gisaf_admin

    class Admin:
        menu = 'Other'
        flask_admin_model_view = 'ReconciliationModelView'

    id: int = Field(primary_key=True, sa_column=Column(BigInteger, autoincrement=False))
    target: str = Field(sa_column=Column(String(50)))
    source: str = Field(sa_column=Column(String(50)))


class StatusChange(Model):
    metadata = gisaf_admin
    __tablename__ = 'status_change'

    id: int = Field(BigInteger, primary_key=True, sa_column=Column(autoincrement=False))
    store: str = Field(sa_column=Column(String(50)))
    ref_id: int = Field(sa_column=Column(BigInteger()))
    original: str = Field(sa_column=Column(String(1)))
    new: str = Field(sa_column=Column(String(1)))
    time: datetime


class FeatureDeletion(Model):
    metadata = gisaf_admin
    __tablename__ = 'feature_deletion'

    id: int = Field(BigInteger, primary_key=True, sa_column=Column(autoincrement=False))
    store: str = Field(sa_column=Column(String(50)))
    ref_id: int = Field(sa_column=Column(BigInteger()))
    time: datetime